//
// Created by HW on 2023/07/26.
//

// You may need to build the project (run Qt uic code generator) to get "ui_MainWindowLagout.h" resolved

#include "mainwindowlayout.h"
#include "ui_MainWindowLayout.h"

MainWindowLayout::MainWindowLayout(QWidget *parent) :
        QWidget(parent), ui(new Ui::MainWindowLayout) {
    ui->setupUi(this);
    layout=new QVBoxLayout(this);
	mainWindowLayout = this;
	ConfigRequest *configRequest = new ConfigRequest;
	configResponse = new ConfigResponse;
	configRequest->sendRequest(configResponse);
	mainScreen = new MainScreen(this);
    navBar=new NavBar(configResponse,mainScreen,this);
	navBar->setAttribute(Qt::WA_DeleteOnClose);
	delete configRequest;
    //QSizePolicy sizePolicy(QSizePolicy::Policy::Fixed, QSizePolicy::QSizePolicy::Fixed);
    //navBar->setSizePolicy(sizePolicy);
    layout->setMargin(0);
    layout->addWidget(navBar,1);
    layout->addWidget(mainScreen,7);
    setLayout(layout);
	connect(this,&MainWindowLayout::clickButton1,mainScreen,&MainScreen::clickButton1);
}

MainWindowLayout::~MainWindowLayout() {
	delete configResponse;
	layout->removeWidget(mainScreen);
	layout->removeWidget(navBar);
	delete mainScreen;
    //delete[] list[0];
    delete navBar;
    delete layout;
    delete ui;
}

void MainWindowLayout::resizeEvent(QResizeEvent *event) {
    QWidget::resizeEvent(event);
    navBar->resize(navBar->width(),height()/8);
    //layout->setAlignment(Qt::AlignmentFlag::AlignHCenter);
}

void MainWindowLayout::clickButton(QString text, QString url) {
	QString path = QApplication::applicationDirPath();
	path += "/startcalc.exe";
	if (text== QString::fromLocal8Bit("")) {
		WinExec(path.toStdString().c_str(), SW_SHOW);
	}
	else{
		emit clickButton1(text, url);
	}
}

MainWindowLayout *mainWindowLayout;
