#include "switchbutton.h"
#include "config.h"
#include <Windows.h>
#include <QMessageBox>
#include <QFile>
SwitchButton::SwitchButton(int action,QWidget *parent=nullptr)
	: QWidget(parent)
{
	ui.setupUi(this);
	checked = false;
	this->action = action;
	//ʱɫ
	bgColorOff = QColor(225, 225, 225);
	bgColorOn = QColor(250, 250, 250);

	//ʱɫ
	sliderColorOff = QColor(100, 100, 100);
	sliderColorOn = QColor(100, 184, 255);

	space = 2;  //
	rectRadius = 5;

	step = width() / 50;  //

						  //ʼĿλ
	startX = 0;
	endX = 0;

	timer = new QTimer(this);
	timer->setInterval(10);
	connect(timer, &QTimer::timeout, this, &SwitchButton::updateValue);

}

void SwitchButton::updateValue()
{
	if (checked) {
		if (startX < endX) {
			startX = startX + step;
		}
		else {
			startX = endX;
			timer->stop();
		}
	}
	else {
		if (startX > endX) {
			startX = startX - step;
		}
		else {
			startX = endX;
			timer->stop();
		}
	}

	update();
}
void SwitchButton::mousePressEvent(QMouseEvent *event)
{
	QWidget::mousePressEvent(event);
	checked = !checked;
	if (action == ADD_AUTOSTART) {
		if (checked == true) {
			HKEY hRoot = HKEY_CURRENT_USER;
			wchar_t *szSubKey = L"Software\\Microsoft\\Windows\\CurrentVersion\\Run";
			HKEY hKey;
			DWORD dwDisposition = REG_OPENED_EXISTING_KEY;    // ڲ
			LONG lRet = RegCreateKeyEx(hRoot, szSubKey, 0, NULL,
				REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisposition);
			if (lRet != ERROR_SUCCESS) {
				QMessageBox::critical(this, QString::fromLocal8Bit("ʾ"), QString::fromLocal8Bit("ʧ"));
				return;
			}
			QString app = QApplication::applicationFilePath();
			lRet = RegSetValueEx(hKey, L"SelfRun", 0, REG_SZ, (BYTE*)app.toStdWString().c_str(), app.length());
			if (lRet == ERROR_SUCCESS)
			{
				QMessageBox::information(this, QString::fromLocal8Bit("ʾ"), QString::fromLocal8Bit("ɹ"));
			}
			RegCloseKey(hKey);
		}
		else {
			HKEY hRoot = HKEY_CURRENT_USER;
			wchar_t *szSubKey = L"Software\\Microsoft\\Windows\\CurrentVersion\\Run";
			HKEY hKey;
			DWORD dwDisposition = REG_OPENED_EXISTING_KEY;    // ڲ
			LONG lRet = RegCreateKeyEx(hRoot, szSubKey, 0, NULL,
				REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisposition);
			if (lRet != ERROR_SUCCESS) {
				QMessageBox::critical(this, QString::fromLocal8Bit("ʾ"), QString::fromLocal8Bit("Ƴʧ"));
				return;
			}
			QString app = QApplication::applicationFilePath();
			lRet = RegDeleteValue(hKey, L"SelfRun");
			if (lRet == ERROR_SUCCESS)
			{
				QMessageBox::information(this, QString::fromLocal8Bit("ʾ"), QString::fromLocal8Bit("Ƴɹ"));
			}
			RegCloseKey(hKey);
		}
	}

	//ÿƶĲΪȵ 50֮һ
	step = width() / 50;

	//״̬лıԶյ
	if (checked)
	{
		endX = width() - width() / 2;
	}
	else
	{
		endX = 0;
	}

	timer->start();
}

void SwitchButton::resizeEvent(QResizeEvent *event)
{
	QWidget::resizeEvent(event);
	//ÿƶĲΪȵ 50֮һ
	step = width() / 50;

	//ߴСıԶΪյ
	if (checked)
	{
		startX = width() - width() / 2;
	}
	else
	{
		startX = 0;
	}

	update();
}
void SwitchButton::paintEvent(QPaintEvent *event)
{
	QWidget::paintEvent(event);
	//׼,÷
	
	QPainter painter(this);
	painter.setRenderHint(QPainter::Antialiasing);
	//Ʊ
	drawBg(&painter);
	//ƻ
	drawSlider(&painter);
}

void SwitchButton::drawBg(QPainter *painter)
{
	painter->save();

	painter->setPen(Qt::NoPen);
	if (!checked)
	{
		painter->setBrush(bgColorOff);
	}
	else
	{
		painter->setBrush(bgColorOn);
	}
	painter->drawRoundedRect(rect(), rectRadius, rectRadius);

	painter->restore();
}
void SwitchButton::drawSlider(QPainter *painter)
{
	painter->save();

	painter->setPen(Qt::NoPen);
	if (!checked) {
		painter->setBrush(sliderColorOff);
	}
	else {
		painter->setBrush(sliderColorOn);
	}
	int sliderWidth = width() / 2 - space * 2;
	int sliderHeight = height() - space * 2;
	QRect sliderRect(startX + space, space, sliderWidth, sliderHeight);
	painter->drawRoundedRect(sliderRect, rectRadius, rectRadius);

	painter->restore();
}

SwitchButton::~SwitchButton()
{
}
